#!/usr/bin/python3
# coding=utf-8
import os
import re
import sys
import json
import time
# import urllib.request as request
import threading
import py3_down as _

UA = "Mozilla/5.0 (Linux; Android 7.1.2; PIXEL 2 XL Build/NOF26V; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36"
HTTPS = "https://"
GAME_HOST = "magiproxy.tanya.workers.dev"
log = True

def getChars():
    chars = []
    dl = os.listdir(_.makepath(_.SAVE_DIR, 'resource/image_native/card/image/'))
    for m in dl:
        mo = re.match(r'^card_(\d{4})\d_c.png$', m)
        if not mo: continue
        char = int(mo.group(1))
        if not char in chars: chars.append(char)
    chars.sort()
    return chars

def main():
    d_piece = 0
    d_size = 0
    d_recv = 0
    d_count = 0
    _.errorCheck()
    # chars = getChars()
    threads_list = []
    JSON_LIST = ['asset_%dhigh.json' % i for i in getChars()]
    if not _.quite: print('[*] Updating asset lists ...')
    # for i in chars:
    #    item = 'asset_%dhigh.json' % i
    for item in JSON_LIST:
        if not _.quite: print('[-] Updating list %s ...' % str(item))
        if _.MAXTHREAD > 1: threads_list.append(threading.Thread(target=_.download, args=(item, )))
        else: _.download(item)
    for t in threads_list:
        while threading.activeCount() > _.MAXTHREAD: time.sleep(.5)
        t.start()
        if len(_.dbevent): _.dbevent.pop().run()
    for t in threads_list:
        t.join()
        if len(_.dbevent): _.dbevent.pop().run()
    try:
        exists = _.select_all('download_asset')
        d_list = []
        d_recv = 0
        d_count = 0
        for fjson in JSON_LIST:
            # if not quite: print('[*] Loading %s ...' % str(fjson))
            try:
                lst = _.read_json(_.makepath(_.SAVE_DIR, fjson))
            except KeyboardInterrupt:
                raise
            except json.decoder.JSONDecodeError:
                continue
            # if not quite: print('[-] Found %d items' % len(lst))
            for i in lst:
                if i in d_list: continue
                key = "resource/" + i['path']
                path = _.makepath(_.SAVE_DIR, key)
                size = 0
                cntp = 0
                for p in i['file_list']:
                    cntp += 1
                    size += p['size']
                if not os.path.exists(path) or _.fsize(path) != size or key not in exists or exists[key] != i['md5']:# or _.md5sum(path) != i['md5']:
                    d_piece += cntp
                    d_size += size
                    d_list.append(i)
                    if _.verbose: print('[ ] ' + i['path'])
        if not len(d_list): return 0
        if log:
            hdir = _.makepath(_.SAVE_DIR, "history")
            if not os.access(hdir, os.F_OK):
                os.makedirs(hdir)
            with open(_.makepath(hdir, time.strftime("%Y%m%d_%H%M", time.localtime()) + '.html'), 'w') as f:
                #with open(_.makepath(_.SAVE_DIR, 'history/head.html'), 'w') as h: f.write(h.read())
                for i in d_list: f.write('<li><a href="/magica/resource/' + i['path'] + '">' + i['path'] + "</a>&emsp;(" + i['md5'] + ")" + "</li>\n")
                #with open(_.makepath(_.SAVE_DIR, 'history/foot.html'), 'w') as h: f.write(h.read())
        print('[>] Summary: ' + str(len(d_list)) + ' files, with ' + str(d_piece) + ' pieces, size: ' + _.human_int(d_size) + '. ', end='')
        if _.quite:
            print()
        else:
            print('Y/n? ', end='')
            k = input()
            if k and k != 'Y' and k != 'y':
                print('[<] Abort.')
                return -1
            print('[>] Press Ctrl+C ONCE to break')
        if not _.quite: print('[*] Start download ...')
        _.d_piece = d_piece
        _.d_size = d_size
        _.d_recv = d_recv
        _.d_count = d_count
        cnt = 0
        threads_list = []
        for i in d_list:
            cnt += 1
            if len(i['file_list']) > 1 or i['file_list'][0]['url'] != i['path']:
                if _.MAXTHREAD > 1: t = threading.Thread(target=_.download_p, args=(i, ))
                else: _.download_p(i)
            else:
                key = "resource/" + i['path']
                if _.MAXTHREAD > 1: t = threading.Thread(target=_.download, args=(key, 1, i['md5'], ))
                else: _.download(key, 1, i['md5'])
            if _.MAXTHREAD > 1: threads_list.append(t)
        for t in threads_list:
            while threading.activeCount() > _.MAXTHREAD: time.sleep(.5)
            t.start()
            if len(_.dbevent): _.dbevent.pop().run()
        for t in threads_list:
            t.join()
            if len(_.dbevent): _.dbevent.pop().run()
        while len(_.dbevent): _.dbevent.pop().run()
        print()
        print('[.] Finished.')
    except KeyboardInterrupt:
        print()
        print('[<] Abort by user.')
        return -1
    except:
        print('[x] Runtime Error')
        raise
    if len(_.FAILLIST) > 0:
        with open(_.makepath(_.SAVE_DIR, 'fail.log'), 'w') as f:
            f.write("Log time: " + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + "\n")
            print("[!] Fail list:")
            for item in _.FAILLIST:
                print("[x] " + item)
                f.write(item + "\n")
    return 0;

pram = ""
if __name__ == '__main__':
    for i in sys.argv:
        if pram:
            if pram == 'U':
                _.UA = i
            elif pram == 'H':
                t = re.match(r'^http(s)?://(.*)', i)
                if t:
                    GAME_HOST = t.group(2)
                    HTTPS = "https://" if t.group(1) else "http://"
                else: GAME_HOST = i
            elif pram == 'r':
                if HTTPS == "http://": _.CURL_CONFIG += ' --resolve ' + GAME_HOST + ':80:' + i
                else:                  _.CURL_CONFIG += ' --resolve ' + GAME_HOST + ':443:' + i
            elif pram == 'P':
                _.CURL_CONFIG += ' -x ' + i
            elif pram == 's':
                _.SAVE_DIR = i
            pram = ""
            continue
        if i[0] == '-':
            if i == '-h' or i == '--help':
                print('Usage: python3 py3_down.py [option] [MAXTHREAD = 7]')
                print('Magia Record mulit-thread data downloader, base on cURL.')
                print('    -h, --help   Show this help.')
                print('    -q, -y       Quite mode, download without ask.')
                print('    -n           Do not write html history.')
                print('    -c           remove split pieces (*.a??).')
                print('    -t           Touch file with server time.')
                print('    -v           Show download list.')
                print('    -U UserAgent Set custom UA.')
                print('    -H Host      Set Magireco domain. Must before -r.')
                print('    -r ip        Set ip for Magireco domain.')
                print('    -P proxy     Set proxy for cURL.')
                print('    -s dir       Set Save dir.')
                print('    MAXTHREAD    Maximum thread number. When 1 set to single thread mode.')
                exit(0)
            if i in ['-U', '-H', '-r', '-P', '-s']:
                pram = i[1:]
                continue
            if i[1] == 'q' or i[1] == 'y':
                _.quite = True
                continue
            if i[1] == 'n':
                log = False
                continue
            if i[1] == 'c':
                clean = True
                continue
            if i[1] == 't':
                _.ttime = True
                continue
            if i[1] == 'v':
                _.verbose = True
                continue
        else: 
            if i.isdigit():
                _.MAXTHREAD = int(i)
    # Config
    _.CURL_CONFIG += ' -H "User-Agent: ' + _.UA + '"'
    _.MASTER_PATH = HTTPS + GAME_HOST + "/magica/resource/download/asset/master/"
    _.ERROR403 = HTTPS + GAME_HOST
    _.RESOURCE_DIR = _.makepath(_.SAVE_DIR, "resource")
    _.db = _.sqlite3.connect(_.makepath(_.SAVE_DIR, 'madomagi.db'))

    # Strat
    print('[' + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + ']')
    r = main()
    print('[' + time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) + ']')
    exit(r)
